

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.3.43. object_remove &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.3.44. plugin_register" href="plugin_register.html" />
    <link rel="prev" title="7.3.42. object_list" href="object_list.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/commands/object_remove.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="plugin_register.html" title="7.3.44. plugin_register"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="object_list.html" title="7.3.42. object_list"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" accesskey="U"><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.43. </span><code class="docutils literal notranslate"><span class="pre">object_remove</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="object-remove">
<h1><span class="section-number">7.3.43. </span><code class="docutils literal notranslate"><span class="pre">object_remove</span></code><a class="headerlink" href="#object-remove" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.3.43.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified added">New in version 6.0.0.</span></p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">object_remove</span></code> removes an object. You can remove any object
including table, column, command and so on. Normally, you should use
specific remove command such as <a class="reference internal" href="table_remove.html"><span class="doc">table_remove</span></a> and
<a class="reference internal" href="column_remove.html"><span class="doc">column_remove</span></a>.</p>
<p><code class="docutils literal notranslate"><span class="pre">object_remove</span></code> is danger because you can remove any object. You
should use <code class="docutils literal notranslate"><span class="pre">object_remove</span></code> carefully.</p>
<p><code class="docutils literal notranslate"><span class="pre">object_remove</span></code> has “force mode”. You can remove a broken object by
“force mode”. “Force mode” is useful to resolve problems reported by
<a class="reference internal" href="../executables/grndb.html"><span class="doc">grndb</span></a>.</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.3.43.2. </span>Syntax<a class="headerlink" href="#syntax" title="Permalink to this headline">¶</a></h2>
<p>This command takes two parameters:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>object_remove name
              [force=no]
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.3.43.3. </span>Usage<a class="headerlink" href="#usage" title="Permalink to this headline">¶</a></h2>
<p>You can remove an object in the database specified by <code class="docutils literal notranslate"><span class="pre">name</span></code>:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>object_remove Users
# [
#   [
#     -22,
#     1337566253.89858,
#     0.000355720520019531,
#     &quot;[object][remove] target object doesn&#39;t exist: &lt;Users&gt;&quot;,
#     [
#       [
#         &quot;command_object_remove&quot;,
#         &quot;proc_object.c&quot;,
#         118
#       ]
#     ]
#   ],
#   false
# ]
table_create Users TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
object_remove Users
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>The <code class="docutils literal notranslate"><span class="pre">object_remove</span> <span class="pre">Users</span></code> returns <code class="docutils literal notranslate"><span class="pre">false</span></code> before you create
<code class="docutils literal notranslate"><span class="pre">Users</span></code> table.</p>
<p>The <code class="docutils literal notranslate"><span class="pre">object_remove</span> <span class="pre">Users</span></code> returns <code class="docutils literal notranslate"><span class="pre">true</span></code> after you create <code class="docutils literal notranslate"><span class="pre">Users</span></code>
table.</p>
<p>You can’t remove a broken object by default:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Users TABLE_HASH_KEY ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
thread_limit 1
# [[0, 1337566253.89858, 0.000355720520019531], 1]
database_unmap
# [[0, 1337566253.89858, 0.000355720520019531], true]
% echo &quot;BROKEN&quot; &gt; ${DB_PATH}.0000100

object_remove Users
# [
#   [
#     -22,
#     1337566253.89858,
#     0.000355720520019531,
#     &quot;[object][remove] failed to open the target object: &lt;Users&gt;&quot;,
#     [
#       [
#         &quot;command_object_remove&quot;,
#         &quot;proc_object.c&quot;,
#         113
#       ]
#     ]
#   ],
#   false
# ]
object_exist Users
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>You can remove a broken object by <code class="docutils literal notranslate"><span class="pre">--force</span> <span class="pre">yes</span></code>:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>object_remove Users --force yes
# [
#   [
#     -65,
#     1337566253.89858,
#     0.000355720520019531,
#     &quot;[io][open] file size is too small: &lt;7&gt;(required: &gt;= 64): &lt;/tmp/groonga-databases/commands_object_remove.0000100&gt;&quot;,
#     [
#       [
#         &quot;grn_io_open&quot;,
#         &quot;io.c&quot;,
#         604
#       ]
#     ]
#   ],
#   false
# ]
object_exist Users
# [[0, 1337566253.89858, 0.000355720520019531], false]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">--force</span> <span class="pre">yes</span></code> means you enable “force mode”. You can remove a broken
object in “force mode”.</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.3.43.4. </span>Parameters<a class="headerlink" href="#parameters" title="Permalink to this headline">¶</a></h2>
<p>This section describes all parameters.</p>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.3.43.4.1. </span>Required parameters<a class="headerlink" href="#required-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is only one required parameter.</p>
<div class="section" id="name">
<span id="object-remove-name"></span><h4><span class="section-number">7.3.43.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">name</span></code><a class="headerlink" href="#name" title="Permalink to this headline">¶</a></h4>
<p>Specifies the object name to be removed.</p>
<p>If you want to remove a column, use <code class="docutils literal notranslate"><span class="pre">TABLE_NAME.COLUMN_NAME</span></code> format
like the following:</p>
<p>Execution example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Logs TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Logs timestamp COLUMN_SCALAR Time
# [[0, 1337566253.89858, 0.000355720520019531], true]
object_remove Logs.timestamp
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">Logs</span></code> is table name and <code class="docutils literal notranslate"><span class="pre">timestamp</span></code> is column name in
<code class="docutils literal notranslate"><span class="pre">Logs.timestamp</span></code>.</p>
</div>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.3.43.4.2. </span>Optional parameters<a class="headerlink" href="#optional-parameters" title="Permalink to this headline">¶</a></h3>
<p>There is one optional parameter.</p>
<div class="section" id="force">
<h4><span class="section-number">7.3.43.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">force</span></code><a class="headerlink" href="#force" title="Permalink to this headline">¶</a></h4>
<p>Specifies whether removing the object in “force mode”.</p>
<p>You can’t remove a broken object by default. But you can remove a
broken object in “force mode”.</p>
<p><code class="docutils literal notranslate"><span class="pre">force</span></code> value must be <code class="docutils literal notranslate"><span class="pre">yes</span></code> or <code class="docutils literal notranslate"><span class="pre">no</span></code>. <code class="docutils literal notranslate"><span class="pre">yes</span></code> means that “force
mode” is enabled. <code class="docutils literal notranslate"><span class="pre">no</span></code> means that “force mode” is disabled.</p>
<p>The default value is <code class="docutils literal notranslate"><span class="pre">no</span></code>. It means that “force mode” is disabled by
default.</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.3.43.5. </span>Return value<a class="headerlink" href="#return-value" title="Permalink to this headline">¶</a></h2>
<p>The command returns <code class="docutils literal notranslate"><span class="pre">true</span></code> as body when the command removed the
specified object without any error. For example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, true]
</pre></div>
</div>
<p>The command returns <code class="docutils literal notranslate"><span class="pre">false</span></code> as body when the command gets any
errors. For example:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[HEADER, false]
</pre></div>
</div>
<p>See <a class="reference internal" href="../command/output_format.html"><span class="doc">Output format</span></a> for <code class="docutils literal notranslate"><span class="pre">HEADER</span></code>.</p>
<p>Note that <code class="docutils literal notranslate"><span class="pre">false</span></code> doesn’t mean that “the command can’t remove the
object”. If you enable “force mode”, the command removes the object
even if the object is broken. In the case, the object is removed and
<code class="docutils literal notranslate"><span class="pre">false</span></code> is returned as body.</p>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.3.43. <code class="docutils literal notranslate"><span class="pre">object_remove</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.3.43.1. Summary</a></li>
<li><a class="reference internal" href="#syntax">7.3.43.2. Syntax</a></li>
<li><a class="reference internal" href="#usage">7.3.43.3. Usage</a></li>
<li><a class="reference internal" href="#parameters">7.3.43.4. Parameters</a><ul>
<li><a class="reference internal" href="#required-parameters">7.3.43.4.1. Required parameters</a><ul>
<li><a class="reference internal" href="#name">7.3.43.4.1.1. <code class="docutils literal notranslate"><span class="pre">name</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.3.43.4.2. Optional parameters</a><ul>
<li><a class="reference internal" href="#force">7.3.43.4.2.1. <code class="docutils literal notranslate"><span class="pre">force</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.3.43.5. Return value</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="object_list.html"
                        title="previous chapter"><span class="section-number">7.3.42. </span><code class="docutils literal notranslate"><span class="pre">object_list</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="plugin_register.html"
                        title="next chapter"><span class="section-number">7.3.44. </span><code class="docutils literal notranslate"><span class="pre">plugin_register</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="plugin_register.html" title="7.3.44. plugin_register"
             >next</a> |</li>
        <li class="right" >
          <a href="object_list.html" title="7.3.42. object_list"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../command.html" ><span class="section-number">7.3. </span>Command</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.3.43. </span><code class="docutils literal notranslate"><span class="pre">object_remove</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>